#!/bin/bash

docker build --quiet --tag docker-youki .

run-test () {
    RUNTIME="$1"
    shift
    docker run --rm -it \
        --cap-add=ALL \
        "$@" \
        --security-opt=seccomp=unconfined \
        --cgroupns=host \
        -v /sys/fs/cgroup:/sys/fs/cgroup \
        -v /var \
        docker-youki \
        /bin/sh -c \
        "dind dockerd 2> /dev/null & sleep 1 && docker run --runtime=$RUNTIME --rm --cap-drop=ALL hello-world" > /dev/null
    
    STATUS="$?"
    if [ "$STATUS" == "0" ]; then
        echo "Runtime $RUNTIME works with --cap-add=ALL $@"
    else
        echo "Runtime $RUNTIME fails (status $STATUS) with --cap-add=ALL $@"
    fi
}

run-test youki
run-test youki --cap-drop=BPF
run-test runc --cap-drop=BPF
